/*
  Часы с отображением температуры и влажности с индикацией на VFD (ВЛИ) дисплее покупателя 20*2 Futaba (vfd9cb1010 rev 1.2)
  AMatroskin 2020 год. Modded by devICEpro. Display is POSLAB PL-200 (без "F" в конце)
*/

#include <GyverButton.h>
#include <SoftwareSerial.h>
#include <Wire.h>
#include <iarduino_RTC.h>
#include <Adafruit_BME280.h>

#define SEALEVELPRESSURE_HPA (1010.7)
#define BTN1 17 //____________________________________________________Пины кнопок
#define BTN2 16
#define BTN3 15

#define COR_TEMP 0     //_____________________________________________Коректирвка температуры (вычитается из показаний датчика)
//#define FIRST_LEVEL 8 //_____________________________________________Уровни переключения яркости
//#define SECOND_LEVEL 150
//#define THIRD_LEVEL  210
//#define SHIFT 0  //___________________________________________________Изменение порядка отображения на экране время -> температура/влажность и наоборот происходит раз в 10 минут
//____________________________________________________________________1 -автоматическая перестановка включена, 0 - выключена. (Уменьшение неравномерности износа люминофора)

Adafruit_BME280 bme; //______________________________________________Объекты датчика температуры/влажности, часов RTC, последовательного порта и кнопок
iarduino_RTC watch(RTC_DS3231);
SoftwareSerial mySerial(11, 10);
GButton butt1(BTN1);
GButton butt2(BTN2);
GButton butt3(BTN3);

int temp_round, temp_round_c1, temp_round_c2, temp_round_d; //_______Переменные для отображения температуры
int hum_round, hum_round_c1, hum_round_c2, hum_round_d;  //__________Переменные для отображения влажности
uint32_t counter = 0, counter2 = 0; //____________________________Переменные счетчиков

//int val_filter; //___________________________________________________Переменные для фильтра датчика освещенности
//long average;
//int valArray[10];
//byte idx = 0;

byte index, min_hour = 0; //_________________________________________Служебные переменные
bool flag = 1, flag2 = 0, set_view = 0, SHIFT = 1, font = 1;

String up_half [12] { //_____________________________________________Верхние половины цифр
  "\320\321", // ноль
  "\324\325", // один
  "\330\331", // два
  "\334\335", // три
  "\340\341", // четыре
  "\344\345", // пять
  "\350\351", // шесть
  "\354\355", // семь
  "\360\361", // восемь
  "\364\365", // девять
  "\370",     // :
};

String down_half [12] { //___________________________________________Нижние половины цифр
  "\322\323", // ноль
  "\326\327", // один
  "\332\333", // два
  "\336\337", // три
  "\342\343", // четыре
  "\346\347", // пять
  "\352\353", // шесть
  "\356\357", // семь
  "\362\363", // восемь
  "\366\367", // девять
  "\371",     // :
};

String up_half_w [12] { //_____________________________________________Верхние половины цифр
  "\240\244\242", // ноль
  "\247\250\40",  // один
  "\254\244\255", // два
  "\254\260\261", // три
  "\264\265\40",  // четыре
  "\271\246\272", // пять
  "\240\273\274", // шесть
  "\275\276\277", // семь
  "\301\246\261", // восемь
  "\303\244\242", // девять
  "\370",         // :
};

String down_half_w [12] { //___________________________________________Нижние половины цифр
  "\241\245\243", // ноль
  "\252\251\253", // один
  "\256\246\257", // два
  "\263\245\262", // три
  "\266\267\270", // четыре
  "\263\245\262", // пять
  "\241\245\262", // шесть
  "\40\300\40",   // семь
  "\302\245\262", // восемь
  "\304\305\243", // девять
  "\371",         // :
};

void setup() {
  delay(12000); //____________тут надо подождать
  pinMode(10, OUTPUT);
  watch.begin();
  bme.begin(0x76);
  mySerial.begin(19600);
  Serial.begin(9600);
  mySerial.write(0x1B); //
  mySerial.write(0x40); //____инициализация дисплея
  delay(500); //_____________и тут надо подождать
  CustomFontLoad(); //________загрузка своего шрифта
  delay(500); //_____________и тут надо подождать
  CustomFontLoadWide(); //________загрузка своего шрифта

  //  for (byte i; i < 10; i++) { //_Набираем массив значений с датчика освещенности для корректной работы сразу после запуска
  //    Light (analogRead(20)); //___Датчик света подключен к 20 пину (А6)
  //  }
}

void loop() {
  butt1.tick();
  butt2.tick();
  butt3.tick();

  if (butt1.isHolded() && butt1.isHold()) { //__Переключение режимов отображения/настройки времени
    set_view = ! set_view;
    mySerial.write(0x0b); //____________________курсор домой
  }
  switch (set_view) {
    case 0:   //________________________________Выводим время и устанавливаем яркость экрана раз в секунду
      min_hour = 0;
      if (millis() - counter >= 500) {
        show_time ();
        flag = ! flag;
        counter += 500;
        if (butt2.isHolded() && butt2.isHold()) { //Переключение шрифтов
          font = ! font;
        }
        if (butt3.isHolded() && butt3.isHold()) { //Переключение режима сдвига дисплея
          SHIFT = ! SHIFT;
        }

        //        if ((Light (analogRead(20)) > THIRD_LEVEL)) {
        //          set_brightness(4);
        //        }
        //        if (((Light (analogRead(20)) <= THIRD_LEVEL)) && ((Light (analogRead(20))) > SECOND_LEVEL) ) {
        //          set_brightness(3);
        //        }
        //        if (((Light (analogRead(20)) <= SECOND_LEVEL)) && ((Light (analogRead(20)) > FIRST_LEVEL) )) {
        //          set_brightness(2);
        //        }
        //        if (Light (analogRead(20)) <= FIRST_LEVEL)  {
        //          set_brightness(1);
        //        }
      }
      break;

    case 1: //________________________________Устанавливаем время
      //      butt2.tick();
      //      butt3.tick();
      if (butt1.isClick()) {
        min_hour ++;
      }
      if (min_hour > 5) min_hour = 0;
      if (millis() - counter >= 200) {
        counter += 200;
        set_time();
      }
      break;
  }

  if (millis() - counter2 >= 5000) { //_______получаем температуру и влажность раз в 5 секунд
    counter2 += 5000;
    get_temp();
  }

}

void CustomFontLoad() { //_____________________________Создаем свои символы
  mySerial.write(0x1B);
  mySerial.write(0x25);
  mySerial.write(0x01); // Разрешаем кастомные символы

  mySerial.write(0x1B);
  mySerial.write(0x26);
  mySerial.write(0x01); // Начинаем запись кастомных символов
  mySerial.write(0xd0); // Первый адрес диапазона
  mySerial.write(0xfb); // Последний адрес диапазона

  //_________________________Создание символов

  mySerial.write(0x05); // Размер символа 5 байт
  mySerial.write(0x1F); // Большой ноль 1
  mySerial.write(0x3F); // \320
  mySerial.write(0X70);
  mySerial.write(0x60);
  mySerial.write(0x60);

  mySerial.write(0x05); // Размер символа 5 байт
  mySerial.write(0x63); // Большой ноль 2
  mySerial.write(0x67); // \321
  mySerial.write(0x76);
  mySerial.write(0x3F);
  mySerial.write(0x1F);

  mySerial.write(0x05); // Размер символа 5 байт
  mySerial.write(0x7C); // Большой ноль 3
  mySerial.write(0x7E); // \322
  mySerial.write(0x37);
  mySerial.write(0x73);
  mySerial.write(0x63);

  mySerial.write(0x05); // Размер символа 5 байт
  mySerial.write(0x3); // Большой ноль 4
  mySerial.write(0x3); // \323
  mySerial.write(0x7);
  mySerial.write(0x7E);
  mySerial.write(0x7C);

  mySerial.write(0x05); // Размер символа 5 байт
  mySerial.write((int)0x00); // Единица 1
  mySerial.write((int)0x00); // \324
  mySerial.write((int)0x00);
  mySerial.write(0x18);
  mySerial.write(0x38);

  mySerial.write(0x05); // Размер символа 5 байт
  mySerial.write(0x7F); // Единица 2
  mySerial.write(0x7F); // \325
  mySerial.write((int)0x00);
  mySerial.write((int)0x00);
  mySerial.write((int)0x00);

  mySerial.write(0x05); // Размер символа 5 байт
  mySerial.write((int)0x00); // Единица 3
  mySerial.write((int)0x00); // \326
  mySerial.write((int)0x00);
  mySerial.write(0x3);
  mySerial.write(0x3);

  mySerial.write(0x05); // Размер символа 5 байт
  mySerial.write(0x7F); // Единица 4
  mySerial.write(0x7F); // \327
  mySerial.write(0X3);
  mySerial.write(0x3);
  mySerial.write((int)0x00);

  mySerial.write(0x05); // Размер символа 5 байт
  mySerial.write(0x18); // Двойка 1
  mySerial.write(0x38); // \330
  mySerial.write(0X70);
  mySerial.write(0x60);
  mySerial.write(0x60);

  mySerial.write(0x05); // Размер символа 5 байт
  mySerial.write(0x60); // Двойка 2
  mySerial.write(0x61); // \331
  mySerial.write(0X73);
  mySerial.write(0x3F);
  mySerial.write(0x1E);

  mySerial.write(0x05); // Размер символа 5 байт
  mySerial.write(0x3); // Двойка 3
  mySerial.write(0x7); // \332
  mySerial.write(0XF);
  mySerial.write(0x1F);
  mySerial.write(0x3B);

  mySerial.write(0x05); // Размер символа 5 байт
  mySerial.write(0x73); // Двойка 4
  mySerial.write(0x63); // \333
  mySerial.write(0X43);
  mySerial.write(0x3);
  mySerial.write(0x3);

  mySerial.write(0x05); // Размер символа 5 байт
  mySerial.write(0x60); // Тройка 1
  mySerial.write(0x60); // \334
  mySerial.write(0X60);
  mySerial.write(0x61);
  mySerial.write(0x63);

  mySerial.write(0x05); // Размер символа 5 байт
  mySerial.write(0x67); // Тройка 2
  mySerial.write(0x6E); // \335
  mySerial.write(0X7C);
  mySerial.write(0x78);
  mySerial.write(0x70);

  mySerial.write(0x05); // Размер символа 5 байт
  mySerial.write(0xC); // Тройка 3
  mySerial.write(0xE); // \336
  mySerial.write(0X7);
  mySerial.write(0x43);
  mySerial.write(0x43);

  mySerial.write(0x05); // Размер символа 5 байт
  mySerial.write(0x43); // Тройка 4
  mySerial.write(0x43); // \337
  mySerial.write(0X67);
  mySerial.write(0x7E);
  mySerial.write(0x3C);

  mySerial.write(0x05); // Размер символа 5 байт
  mySerial.write(0x1); // Четверка 1
  mySerial.write(0x3); // \340
  mySerial.write(0X7);
  mySerial.write(0xE);
  mySerial.write(0x1C);

  mySerial.write(0x05); // Размер символа 5 байт
  mySerial.write(0x60); // Четверка 2
  mySerial.write(0x7F); // \341
  mySerial.write(0X7F);
  mySerial.write((int)0x00);
  mySerial.write((int)0x00);

  mySerial.write(0x05); // Размер символа 5 байт
  mySerial.write(0x70); // Четверка 3
  mySerial.write(0x70); // \342
  mySerial.write(0X30);
  mySerial.write(0x30);
  mySerial.write(0x30);

  mySerial.write(0x05); // Размер символа 5 байт
  mySerial.write(0x30); // Четверка 4
  mySerial.write(0x7F); // \343
  mySerial.write(0X7F);
  mySerial.write(0x30);
  mySerial.write(0x30);

  mySerial.write(0x05); // Размер символа 5 байт
  mySerial.write(0x7F); // Пятерка 1
  mySerial.write(0x7F); // \344
  mySerial.write(0X63);
  mySerial.write(0x63);
  mySerial.write(0x63);

  mySerial.write(0x05); // Размер символа 5 байт
  mySerial.write(0x63); // Пятерка 2
  mySerial.write(0x63); // \345
  mySerial.write(0X63);
  mySerial.write(0x61);
  mySerial.write(0x60);

  mySerial.write(0x05); // Размер символа 5 байт
  mySerial.write(0xC); // Пятерка 3
  mySerial.write(0xE); // \346
  mySerial.write(0X7);
  mySerial.write(0x3);
  mySerial.write(0x3);

  mySerial.write(0x05); // Размер символа 5 байт
  mySerial.write(0x3); // Пятерка 4
  mySerial.write(0x3); // \347
  mySerial.write(0X47);
  mySerial.write(0x7E);
  mySerial.write(0x7C);

  mySerial.write(0x05); // Размер символа 5 байт
  mySerial.write(0xF); // Шестерка 1
  mySerial.write(0x1F); // \350
  mySerial.write(0X39);
  mySerial.write(0x73);
  mySerial.write(0x63);

  mySerial.write(0x05); // Размер символа 5 байт
  mySerial.write(0x63); // Шестерка 2
  mySerial.write(0x63); // \351
  mySerial.write(0X63);
  mySerial.write(0x61);
  mySerial.write((int)0x00);

  mySerial.write(0x05); // Размер символа 5 байт
  mySerial.write(0x7C); // Шестерка 3
  mySerial.write(0x7E); // \352
  mySerial.write(0X47);
  mySerial.write(0x43);
  mySerial.write(0x3);

  mySerial.write(0x05); // Размер символа 5 байт
  mySerial.write(0x3); // Шестерка 4
  mySerial.write(0x3); // \353
  mySerial.write(0X47);
  mySerial.write(0x7E);
  mySerial.write(0x7C);

  mySerial.write(0x05); // Размер символа 5 байт
  mySerial.write(0x60); // Семерка 1
  mySerial.write(0x60); // \354
  mySerial.write(0X60);
  mySerial.write(0x60);
  mySerial.write(0x60);

  mySerial.write(0x05); // Размер символа 5 байт
  mySerial.write(0x63); // Семерка 2
  mySerial.write(0x67); // \355
  mySerial.write(0X6E);
  mySerial.write(0x7C);
  mySerial.write(0x78);

  mySerial.write(0x05); // Размер символа 5 байт
  mySerial.write((int)0x00); // Семерка 3
  mySerial.write((int)0x00); // \356
  mySerial.write((int)0x00);
  mySerial.write(0x3F);
  mySerial.write(0x7F);

  mySerial.write(0x05); // Размер символа 5 байт
  mySerial.write((int)0x00); // Семерка 4
  mySerial.write((int)0x00); // \357
  mySerial.write((int)0x00);
  mySerial.write((int)0x00);
  mySerial.write((int)0x00);


  mySerial.write(0x05); // Размер символа 5 байт
  mySerial.write(0x1E); // Восьмерка 1
  mySerial.write(0x3F); // \360
  mySerial.write(0X73);
  mySerial.write(0x61);
  mySerial.write(0x61);

  mySerial.write(0x05); // Размер символа 5 байт
  mySerial.write(0x61); // Восьмерка 2
  mySerial.write(0x61); // \361
  mySerial.write(0X73);
  mySerial.write(0x3F);
  mySerial.write(0x1E);

  mySerial.write(0x05); // Размер символа 5 байт
  mySerial.write(0x3C); // Восьмерка 3
  mySerial.write(0x7E); // \362
  mySerial.write(0X67);
  mySerial.write(0x43);
  mySerial.write(0x43);

  mySerial.write(0x05); // Размер символа 5 байт
  mySerial.write(0x43); // Восьмерка 4
  mySerial.write(0x43); // \363
  mySerial.write(0X67);
  mySerial.write(0x7E);
  mySerial.write(0x3C);

  mySerial.write(0x05); // Размер символа 5 байт
  mySerial.write(0x1F); // Девятка 1
  mySerial.write(0x3F); // \364
  mySerial.write(0X71);
  mySerial.write(0x60);
  mySerial.write(0x60);

  mySerial.write(0x05); // Размер символа 5 байт
  mySerial.write(0x60); // Девятка 2
  mySerial.write(0x60); // \365
  mySerial.write(0X71);
  mySerial.write(0x3F);
  mySerial.write(0x1F);

  mySerial.write(0x05); // Размер символа 5 байт
  mySerial.write((int)0x00); // Девятка 3
  mySerial.write(0x43); // \366
  mySerial.write(0X63);
  mySerial.write(0x63);
  mySerial.write(0x63);

  mySerial.write(0x05); // Размер символа 5 байт
  mySerial.write(0x63); // Девятка 4
  mySerial.write(0x67); // \367
  mySerial.write(0X4E);
  mySerial.write(0x7C);
  mySerial.write(0x78);

  mySerial.write(0x05); // Размер символа 5 байт
  mySerial.write((int)0x00); // Двоеточие верх
  mySerial.write(0xE); // \370
  mySerial.write(0XE);
  mySerial.write(0xE);
  mySerial.write((int)0x00); //

  mySerial.write(0x05); // Размер символа 5 байт
  mySerial.write((int)0x00); // Двоеточие низ
  mySerial.write(0x38); // \371
  mySerial.write(0X38);
  mySerial.write(0x38);
  mySerial.write((int)0x00);

  mySerial.write(0x05); // Размер символа 5 байт
  mySerial.write(0x30); // Значок градуса °
  mySerial.write(0x48); // \372
  mySerial.write(0x48);
  mySerial.write(0x30);
  mySerial.write((int)0x00);
}
void CustomFontLoadWide() { //_____________________________Создаем свои символы
  mySerial.write(0x1B);
  mySerial.write(0x25);
  mySerial.write(0x01); // Разрешаем кастомные символы

  mySerial.write(0x1B);
  mySerial.write(0x26);
  mySerial.write(0x01); // Начинаем запись кастомных символов
  mySerial.write(0xA0); // Первый адрес диапазона
  mySerial.write(0xc6); // Последний адрес диапазона

  //_________________________Создание символов

  mySerial.write(0x05); // Размер символа 5 байт  00000
  mySerial.write((int)0x00);// \240               00001
  mySerial.write((int)0x00);// a0                 00011
  mySerial.write(0x0F);//                         00111
  mySerial.write(0x1F);//                         00111
  mySerial.write(0X3F);//                         00111
  //                                              00111


  mySerial.write(0x05); // Размер символа 5 байт  00111
  mySerial.write((int)0x00); // \241              00111
  mySerial.write((int)0x00); // a1                00111
  mySerial.write(0x78); //                        00111
  mySerial.write(0x7C); //                        00011
  mySerial.write(0x7E); //                        00001
  //                                              00000

  mySerial.write(0x05); // Размер символа 5 байт  00000
  mySerial.write(0x3F); //  \242                  10000
  mySerial.write(0x1F); // a2                     11000
  mySerial.write(0x0F); //                        11100
  mySerial.write((int)0x00); //                   11100
  mySerial.write((int)0x00); //                   11100
  //                                              11100

  mySerial.write(0x05); // Размер символа 5 байт  11100
  mySerial.write(0x7E); // \243                   11100
  mySerial.write(0x7C); // a3                     11100
  mySerial.write(0x78); //                        11100
  mySerial.write((int)0x00); //                   11000
  mySerial.write((int)0x00); //                   10000
  //                                              00000

  mySerial.write(0x05); // Размер символа 5 байт  11111
  mySerial.write(0x60); // \244                   11111
  mySerial.write(0x60); // a4                     00000
  mySerial.write(0x60); //                        00000
  mySerial.write(0x60); //                        00000
  mySerial.write(0x60); //                        00000
  //                                              00000

  mySerial.write(0x05); // Размер символа 5 байт  00000
  mySerial.write(0x03); // \245                   00000
  mySerial.write(0x03); // a5                     00000
  mySerial.write(0x03); //                        00000
  mySerial.write(0x03); //                        00000
  mySerial.write(0x03); //                        11111
  //                                              11111

  mySerial.write(0x05); // Размер символа 5 байт  11111
  mySerial.write(0x63); // \246                   11111
  mySerial.write(0x63); // a6                     00000
  mySerial.write(0x63); //                        00000
  mySerial.write(0x63); //                        00000
  mySerial.write(0x63); //                        11111
  //                                              11111

  mySerial.write(0x05); // Размер символа 5 байт  00000
  mySerial.write((int)0x00); // \247              00000
  mySerial.write((int)0x00); // a7                00000
  mySerial.write((int)0x00); //                   00001
  mySerial.write(0x04); //                        00011
  mySerial.write(0x0C); //                        00000
  //                                              00000

  mySerial.write(0x05); // Размер символа 5 байт  01110
  mySerial.write(0x3C); // \250                   11110
  mySerial.write(0x7F); // a8                     11110
  mySerial.write(0X7F); //                        11110
  mySerial.write(0x7F); //                        11110
  mySerial.write((int)0x00); //                   01110
  //                                              01110

  mySerial.write(0x05); // Размер символа 5 байт  01110
  mySerial.write(0x03); // \251                   01110
  mySerial.write(0x7F); // a9                     01110
  mySerial.write(0X7F); //                        01110
  mySerial.write(0x7F); //                        01110
  mySerial.write(0x03); //                        11111
  //                                              11111

  mySerial.write(0x05); // Размер символа 5 байт  00000
  mySerial.write((int)0x00); // \252              00000
  mySerial.write((int)0x00); // aa                00000
  mySerial.write(0x03); //                        00000
  mySerial.write(0x03); //                        00000
  mySerial.write(0x03); //                        00111
  //                                              00111

  mySerial.write(0x05); // Размер символа 5 байт  00000
  mySerial.write(0x03); // \253                   00000
  mySerial.write(0x03); // ab                     00000
  mySerial.write(0x03); //                        00000
  mySerial.write((int)0x00); //                   00000
  mySerial.write((int)0x00); //                   11100
  //                                              11100

  mySerial.write(0x05); // Размер символа 5 байт  00000
  mySerial.write((int)0x00); //  \254             00011
  mySerial.write((int)0x00); // ac                00111
  mySerial.write(0x18); //                        00110
  mySerial.write(0x38); //                        00000
  mySerial.write(0x30); //                        00000
  //                                              00000

  mySerial.write(0x05); // Размер символа 5 байт  00000
  mySerial.write(0x3F); // \255                   10000
  mySerial.write(0x1F); // ad                     11000
  mySerial.write(0X0E); //                        11100
  mySerial.write((int)0x00); //                   11100
  mySerial.write((int)0x00); //                   11100
  //                                              11000

  mySerial.write(0x05); // Размер символа 5 байт  00000
  mySerial.write((int)0x00); // \256              00001
  mySerial.write((int)0x00); // ae                00011
  mySerial.write(0x0F); //                        00111
  mySerial.write(0x1F); //                        00111
  mySerial.write(0x3F); //                        00111
  //                                              00111

  mySerial.write(0x05); // Размер символа 5 байт  10000
  mySerial.write(0x43); // \257                   00000
  mySerial.write(0x03); // af                     00000
  mySerial.write(0x03); //                        00000
  mySerial.write((int)0x00); //                   00000
  mySerial.write((int)0x00); //                   11100
  //                                              11100

  mySerial.write(0x05); // Размер символа 5 байт  11111
  mySerial.write(0x60); // \260                   11111
  mySerial.write(0x63); // b0                     00000
  mySerial.write(0x63); //                        00000
  mySerial.write(0x63); //                        00000
  mySerial.write(0x63); //                        01111
  //                                              01111

  mySerial.write(0x05); // Размер символа 5 байт  00000
  mySerial.write(0x3F); // \261                   10000
  mySerial.write(0x1E); // b1                     11000
  mySerial.write(0X0C); //                        11100
  mySerial.write((int)0x00); //                   11100
  mySerial.write((int)0x00); //                   11000
  //                                              10000

  mySerial.write(0x05); // Размер символа 5 байт  11000
  mySerial.write(0x7E); // \262                   11100
  mySerial.write(0x7C); // b2                     11100
  mySerial.write(0X38); //                        11100
  mySerial.write((int)0x00); //                   11000
  mySerial.write((int)0x00); //                   10000
  //                                              00000

  mySerial.write(0x05); // Размер символа 5 байт  00000
  mySerial.write((int)0x00); // \263              00000
  mySerial.write((int)0x00); // b3                00000
  mySerial.write(0x0C); //                        00110
  mySerial.write(0x0E); //                        00111
  mySerial.write(0x06); //                        00011
  //                                              00000

  mySerial.write(0x05); // Размер символа 5 байт  00000
  mySerial.write((int)0x00); // \264              00000
  mySerial.write((int)0x00); // b4                00000
  mySerial.write(0x01); //                        00000
  mySerial.write(0x03); //                        00001
  mySerial.write(0x07); //                        00011
  //                                              00111

  mySerial.write(0x05); // Размер символа 5 байт  00111
  mySerial.write(0x18); // \265                   01111
  mySerial.write(0x30); // b5                     11111
  mySerial.write(0X7F); //                        10111
  mySerial.write(0x7F); //                        00111
  mySerial.write(0x7F); //                        00111
  //                                              00111

  mySerial.write(0x05); // Размер символа 5 байт  00111
  mySerial.write((int)0x00); // \266              00111
  mySerial.write((int)0x00); // b6                00111
  mySerial.write(0x70); //                        00000
  mySerial.write(0x70); //                        00000
  mySerial.write(0x70); //                        00000
  //                                              00000

  mySerial.write(0x05); // Размер символа 5 байт  00111
  mySerial.write(0x30); // \267                   11111
  mySerial.write(0x30); // b7                     11111
  mySerial.write(0x7F); //                        00111
  mySerial.write(0x7F); //                        00111
  mySerial.write(0x7F); //                        00111
  //                                              00111

  mySerial.write(0x05); // Размер символа 5 байт  00000
  mySerial.write(0x30); // \270                   11100
  mySerial.write(0x30); // b8                     11100
  mySerial.write(0x30); //                        00000
  mySerial.write((int)0x00); //                   00000
  mySerial.write((int)0x00); //                   00000
  //                                              00000

  mySerial.write(0x05); // Размер символа 5 байт  00111
  mySerial.write((int)0x00); // \271              00111
  mySerial.write((int)0x00); // b9                00111
  mySerial.write(0x7F); //                        00111
  mySerial.write(0x7F); //                        00111
  mySerial.write(0x7F); //                        00111
  //                                              00111

  mySerial.write(0x05); // Размер символа 5 байт  11100
  mySerial.write(0x61); // \272                   11100
  mySerial.write(0x60); // ba                     00000
  mySerial.write(0X60); //                        00000
  mySerial.write((int)0x00); //                   00000
  mySerial.write((int)0x00); //                   00000
  //                                              10000

  mySerial.write(0x05); // Размер символа 5 байт  11111
  mySerial.write(0x61); // \273                   11111
  mySerial.write(0x63); // bb                     00000
  mySerial.write(0x63); //                        00000
  mySerial.write(0x63); //                        00000
  mySerial.write(0x63); //                        01111
  //                                              11111

  mySerial.write(0x05); // Размер символа 5 байт  00000
  mySerial.write(0x31); // \274                   11000
  mySerial.write(0x38); // bc                     11100
  mySerial.write(0X18); //                        01100
  mySerial.write((int)0x00); //                   00000
  mySerial.write((int)0x00); //                   00000
  //                                              10000

  mySerial.write(0x05); // Размер символа 5 байт  00111
  mySerial.write((int)0x00); // \275              00111
  mySerial.write((int)0x00); // bd                00110
  mySerial.write(0X70); //                        00000
  mySerial.write(0x70); //                        00000
  mySerial.write(0x70); //                        00000
  //                                              00000

  mySerial.write(0x05); // Размер символа 5 байт  11111
  mySerial.write(0x60); // \276                   11111
  mySerial.write(0x60); // be                     00000
  mySerial.write(0x60); //                        00000
  mySerial.write(0x61); //                        00000
  mySerial.write(0x63); //                        00001
  //                                              00011

  mySerial.write(0x05); // Размер символа 5 байт  11100
  mySerial.write(0x7C); // \277                   11100
  mySerial.write(0x78); // bf                     11100
  mySerial.write(0x70); //                        11000
  mySerial.write((int)0x00); //                   10000
  mySerial.write((int)0x00); //                   00000
  //                                              00000

  mySerial.write(0x05); // Размер символа 5 байт  01100
  mySerial.write(0x3F); // \300                   11100
  mySerial.write(0x7F); // c0                     11100
  mySerial.write(0X7F); //                        11100
  mySerial.write((int)0x00); //                   11100
  mySerial.write((int)0x00); //                   11100
  //                                              11100

  mySerial.write(0x05); // Размер символа 5 байт  00000
  mySerial.write((int)0x00); // \301              00001
  mySerial.write((int)0x00); // c1                00011
  mySerial.write(0x0C); //                        00111
  mySerial.write(0x1E); //                        00111
  mySerial.write(0x3F); //                        00011
  //                                              00001

  mySerial.write(0x05); // Размер символа 5 байт  00011
  mySerial.write((int)0x00); // \302              00111
  mySerial.write((int)0x00); // c2                00111
  mySerial.write(0X38); //                        00111
  mySerial.write(0x7C); //                        00011
  mySerial.write(0x7E); //                        00001
  //                                              00000

  mySerial.write(0x05); // Размер символа 5 байт  00000
  mySerial.write((int)0x00); // \303              00001
  mySerial.write((int)0x00); // c3                00011
  mySerial.write(0x0E); //                        00111
  mySerial.write(0x1F); //                        00111
  mySerial.write(0x3F); //                        00111
  //                                              00011

  mySerial.write(0x05); // Размер символа 5 байт  00001
  mySerial.write((int)0x00); // \304              00000
  mySerial.write((int)0x00); // c4                00000
  mySerial.write(0x0C); //                        00110
  mySerial.write(0x0E); //                        00111
  mySerial.write(0x46); //                        00011
  //                                              00000

  mySerial.write(0x05); // Размер символа 5 байт  11111
  mySerial.write(0x63); // \305                   11110
  mySerial.write(0x63); // c5                     00000
  mySerial.write(0x63); //                        00000
  mySerial.write(0x63); //                        00000
  mySerial.write(0x43); //                        11111
  //                                              11111

  //  mySerial.write(0x05); // Размер символа 5 байт
  //  mySerial.write((int)0x00); // Девятка 3
  //  mySerial.write(0x43); // \306
  //  mySerial.write(0X63); // c6
  //  mySerial.write(0x63);
  //  mySerial.write(0x63);
  //
  //  mySerial.write(0x05); // Размер символа 5 байт
  //  mySerial.write(0x63); // Девятка 4
  //  mySerial.write(0x67); // \307
  //  mySerial.write(0X4E); // c7
  //  mySerial.write(0x7C);
  //  mySerial.write(0x78);
  //
  //  mySerial.write(0x05); // Размер символа 5 байт
  //  mySerial.write((int)0x00); // Двоеточие верх
  //  mySerial.write(0xE); // \310
  //  mySerial.write(0XE); // c8
  //  mySerial.write(0xE);
  //  mySerial.write((int)0x00); //
  //
  //  mySerial.write(0x05); // Размер символа 5 байт
  //  mySerial.write((int)0x00); // Двоеточие низ
  //  mySerial.write(0x38); // \311
  //  mySerial.write(0X38); // c9
  //  mySerial.write(0x38);
  //  mySerial.write((int)0x00);
  //
  //  mySerial.write(0x05); // Размер символа 5 байт
  //  mySerial.write(0x30); // Значок градуса °
  //  mySerial.write(0x48); // \312
  //  mySerial.write(0x48); //ca
  //  mySerial.write(0x30);
  //  mySerial.write((int)0x00);
}

void show_time () { //_________________________________Отображение времени
  if (font == 1) {
    watch.gettime();
    byte h1, h2, m1, m2, d1, d2;
    String dots_up, dots_down, days, mon;
    if (flag) { //_______________________________________Мигаем точками
      dots_up = up_half [10];
      dots_down = down_half [10];
    } else {
      dots_up = " ";
      dots_down = " ";
    }

    h1 = watch.Hours / 10;
    h2 = watch.Hours % 10;
    m1 = watch.minutes / 10;
    m2 = watch.minutes % 10;
    d1 = watch.day / 10;
    d2 = watch.day % 10;
    mon = watch.gettime("M");
    days = watch.gettime("D");

    String h10_up_w, h10_down_w;  //_________________Гашение старшего ноля
    if (h1 == 0) {
      h10_up_w = "   ";
      h10_down_w = "   ";
    } else {
      h10_up_w = up_half_w [h1];
      h10_down_w = down_half_w [h1];
    }

    //_____________________________________________________Отрисовка содержимого экрана
    if ((SHIFT) && ((m2 % 2) != 0)) { //_____________________Если изменение порядка отображения на экране активно
      mySerial.print(h10_up_w); //_______________________Первая строка: верхние половины больших цифр, точек, значение температуры, символ градуса
      mySerial.print(up_half_w [h2]);
      mySerial.print(dots_up);
      mySerial.print(up_half_w [m1]);
      mySerial.print(up_half_w [m2]);
      mySerial.print("  ");
      mySerial.print(temp_round_c1);
      mySerial.print(temp_round_c2);
      mySerial.print(".");
      mySerial.print(temp_round_d);
      mySerial.print("\372");

      mySerial.print(h10_down_w);  //_____________________Вторая строка: нижние половины больших цифр, точек, влажность
      mySerial.print(down_half_w [h2]);
      mySerial.print(dots_down);
      mySerial.print(down_half_w [m1]);
      mySerial.print(down_half_w [m2]);
      mySerial.print("  ");
      mySerial.print(hum_round_c1);
      mySerial.print(hum_round_c2);
      mySerial.print(".");
      mySerial.print(hum_round_d);
      mySerial.print("%");

    } else if ((SHIFT) && ((m2 % 2) == 0)) {
      mySerial.print("  "); //Дата слева
      mySerial.print(days);
      mySerial.print("  ");
      mySerial.print(h10_up_w); //_______________________Первая строка: день недели, верхние половины больших цифр, точек
      mySerial.print(up_half_w [h2]);
      mySerial.print(dots_up);
      mySerial.print(up_half_w [m1]);
      mySerial.print(up_half_w [m2]);

      mySerial.print(d1); //Дата слева
      mySerial.print(d2);
      mySerial.print(" ");
      mySerial.print(mon);
      mySerial.print(" ");
      mySerial.print(h10_down_w);  //_____________________Вторая строка: дата, месяц ,нижние половины больших цифр, точек
      mySerial.print(down_half_w [h2]);
      mySerial.print(dots_down);
      mySerial.print(down_half_w [m1]);
      mySerial.print(down_half_w [m2]);

    } else { //______________________________________________Если изменение порядка отображения на экране не активно
      if ((m2 % 2) != 0) {
        mySerial.print(h10_up_w); //_______________________Первая строка: верхние половины больших цифр, точек, значение температуры, символ градуса
        mySerial.print(up_half_w [h2]);
        mySerial.print(dots_up);
        mySerial.print(up_half_w [m1]);
        mySerial.print(up_half_w [m2]);
        mySerial.print("  ");
        mySerial.print(temp_round_c1);
        mySerial.print(temp_round_c2);
        mySerial.print(".");
        mySerial.print(temp_round_d);
        mySerial.print("\372");

        mySerial.print(h10_down_w);  //_____________________Вторая строка: нижние половины больших цифр, точек, влажность
        mySerial.print(down_half_w [h2]);
        mySerial.print(dots_down);
        mySerial.print(down_half_w [m1]);
        mySerial.print(down_half_w [m2]);
        mySerial.print("  ");
        mySerial.print(hum_round_c1);
        mySerial.print(hum_round_c2);
        mySerial.print(".");
        mySerial.print(hum_round_d);
        mySerial.print("%");
      }

      else if ((m2 % 2) == 0) {
        mySerial.print(h10_up_w); //_______________________Первая строка: верхние половины больших цифр, точек, день недели
        mySerial.print(up_half_w [h2]);
        mySerial.print(dots_up);
        mySerial.print(up_half_w [m1]);
        mySerial.print(up_half_w [m2]);
        mySerial.print("  "); //Дата справа
        mySerial.print(days);
        mySerial.print("  ");

        mySerial.print(h10_down_w);  //_____________________Вторая строка: нижние половины больших цифр, точек, дата, месяц
        mySerial.print(down_half_w [h2]);
        mySerial.print(dots_down);
        mySerial.print(down_half_w [m1]);
        mySerial.print(down_half_w [m2]);
        mySerial.print(" ");
        mySerial.print(d1); //Дата справа
        mySerial.print(d2);
        mySerial.print(" ");
        mySerial.print(mon);
      }
    }
  } else {
    watch.gettime();
    byte h1, h2, m1, m2, s1, s2, d1, d2, mon1, mon2;
    String dots_up, dots_down, days;
    if (flag) { //_______________________________________Мигаем точками
      dots_up = up_half [10];
      dots_down = down_half [10];
    } else {
      dots_up = " ";
      dots_down = " ";
    }

    h1 = watch.Hours / 10;
    h2 = watch.Hours % 10;
    m1 = watch.minutes / 10;
    m2 = watch.minutes % 10;
    s1 = watch.seconds / 10;
    s2 = watch.seconds % 10;
    d1 = watch.day / 10;
    d2 = watch.day % 10;
    mon1 = watch.month / 10;
    mon2 = watch.month % 10;
    days = watch.gettime("D");

    String h10_up, h10_down;  //_________________Гашение старшего ноля
    if (h1 == 0) {
      h10_up = "  ";
      h10_down = "  ";
    } else {
      h10_up = up_half [h1];
      h10_down = down_half [h1];
    }


    //_____________________________________________________Отрисовка содержимого экрана
    if ((SHIFT) && ((m2 % 2) != 0)) { //_____________________Если изменение порядка отображения на экране активно
      mySerial.print(h10_up); //_______________________Первая строка: верхние половины больших цифр, точек, значение температуры, символ градуса
      mySerial.print(up_half [h2]);
      mySerial.print(dots_up);
      mySerial.print(up_half [m1]);
      mySerial.print(up_half [m2]);
      mySerial.print(dots_up);
      mySerial.print(up_half [s1]);
      mySerial.print(up_half [s2]);
      mySerial.print(" ");
      mySerial.print(temp_round_c1);
      mySerial.print(temp_round_c2);
      mySerial.print(".");
      mySerial.print(temp_round_d);
      mySerial.print("\372");

      mySerial.print(h10_down);  //_____________________Вторая строка: нижние половины больших цифр, точек, влажность
      mySerial.print(down_half [h2]);
      mySerial.print(dots_down);
      mySerial.print(down_half [m1]);
      mySerial.print(down_half [m2]);
      mySerial.print(dots_down);
      mySerial.print(down_half [s1]);
      mySerial.print(down_half [s2]);
      mySerial.print(" ");
      mySerial.print(hum_round_c1);
      mySerial.print(hum_round_c2);
      mySerial.print(".");
      mySerial.print(hum_round_d);
      mySerial.print("%");

    } else if ((SHIFT) && ((m2 % 2) == 0)) {
      mySerial.print(" "); //Дата слева
      mySerial.print(days);
      mySerial.print("  ");
      mySerial.print(h10_up); //_______________________Первая строка: день недели,верхние половины больших цифр, точек
      mySerial.print(up_half [h2]);
      mySerial.print(dots_up);
      mySerial.print(up_half [m1]);
      mySerial.print(up_half [m2]);
      mySerial.print(dots_up);
      mySerial.print(up_half [s1]);
      mySerial.print(up_half [s2]);

      mySerial.print(d1); //Дата слева
      mySerial.print(d2);
      mySerial.print("/");
      mySerial.print(mon1);
      mySerial.print(mon2);
      mySerial.print(" ");
      mySerial.print(h10_down);  //_____________________Вторая строка: дата, месяц, нижние половины больших цифр, точек
      mySerial.print(down_half [h2]);
      mySerial.print(dots_down);
      mySerial.print(down_half [m1]);
      mySerial.print(down_half [m2]);
      mySerial.print(dots_down);
      mySerial.print(down_half [s1]);
      mySerial.print(down_half [s2]);

    } else { //______________________________________________Если изменение порядка отображения на экране не активно
      if ((m2 % 2) != 0) {
        mySerial.print(h10_up); //_______________________Первая строка: верхние половины больших цифр, точек, значение температуры, символ градуса
        mySerial.print(up_half [h2]);
        mySerial.print(dots_up);
        mySerial.print(up_half [m1]);
        mySerial.print(up_half [m2]);
        mySerial.print(dots_up);
        mySerial.print(up_half [s1]);
        mySerial.print(up_half [s2]);
        mySerial.print(" ");
        mySerial.print(temp_round_c1);
        mySerial.print(temp_round_c2);
        mySerial.print(".");
        mySerial.print(temp_round_d);
        mySerial.print("\372");

        mySerial.print(h10_down);  //_____________________Вторая строка: нижние половины больших цифр, точек, влажность
        mySerial.print(down_half [h2]);
        mySerial.print(dots_down);
        mySerial.print(down_half [m1]);
        mySerial.print(down_half [m2]);
        mySerial.print(dots_down);
        mySerial.print(down_half [s1]);
        mySerial.print(down_half [s2]);
        mySerial.print(" ");
        mySerial.print(hum_round_c1);
        mySerial.print(hum_round_c2);
        mySerial.print(".");
        mySerial.print(hum_round_d);
        mySerial.print("%");
      }
      else if ((m2 % 2) == 0) {
        mySerial.print(h10_up); //_______________________Первая строка: верхние половины больших цифр, точек, день недели
        mySerial.print(up_half [h2]);
        mySerial.print(dots_up);
        mySerial.print(up_half [m1]);
        mySerial.print(up_half [m2]);
        mySerial.print(dots_up);
        mySerial.print(up_half [s1]);
        mySerial.print(up_half [s2]);
        mySerial.print("  "); //Дата справа
        mySerial.print(days);
        mySerial.print(" ");

        mySerial.print(h10_down);  //_____________________Вторая строка: нижние половины больших цифр, точек, дата, месяц
        mySerial.print(down_half [h2]);
        mySerial.print(dots_down);
        mySerial.print(down_half [m1]);
        mySerial.print(down_half [m2]);
        mySerial.print(dots_down);
        mySerial.print(down_half [s1]);
        mySerial.print(down_half [s2]);
        mySerial.print(" ");
        mySerial.print(d1); //Дата слева
        mySerial.print(d2);
        mySerial.print("/");
        mySerial.print(mon1);
        mySerial.print(mon2);
      }
    }
  }
}
void get_temp() { //___________________________________Получение данных о температуре и влажности и их обработка (округление, разбиение на разряды)
  temp_round = bme.readTemperature() - COR_TEMP;
  temp_round_c1 = (temp_round / 10);
  temp_round_c2 = (temp_round % 10);
  int d  = (bme.readTemperature() * 10);
  temp_round_d = (d % 10);

  hum_round = bme.readHumidity();
  hum_round_c1 = (hum_round / 10);
  hum_round_c2 = (hum_round % 10);
  int f  = (bme.readHumidity() * 10);
  hum_round_d = (f % 10);
}

//void set_brightness(byte lev) {//______________________Установка яркости дисплея (1 - 4)
//  byte level = lev;
//  switch (level) {
//    case 1:
//      mySerial.write(0x1B); //_________________________Первый уровень яркости
//      mySerial.write(0x2A);
//      mySerial.write(0x01);
//      break;
//    case 2:
//      mySerial.write(0x1B); //_________________________Второй уровень яркости
//      mySerial.write(0x2A);
//      mySerial.write(0x02);
//      break;
//    case 3:
//      mySerial.write(0x1B); //_________________________Третий уровень яркости
//      mySerial.write(0x2A);
//      mySerial.write(0x03);
//      break;
//    case 4:
//      mySerial.write(0x1B); //_________________________Четвертый уровень яркости
//      mySerial.write(0x2A);
//      mySerial.write(0x04);
//      break;
//  }
//}

void set_time() { //___________________________________Экран установки времени
  flag = ! flag;
  if (min_hour == 0) {
    mySerial.print("   Setting hours    ");
  } else if (min_hour == 1) {
    mySerial.print("   Setting minutes  ");
  } else if (min_hour == 2) {
    mySerial.print("   Reset seconds    ");
  } else if (min_hour == 3) {
    mySerial.print("Setting Day of Week ");
  } else if (min_hour == 4) {
    mySerial.print("Setting Day of Month");
  } else if (min_hour == 5) {
    mySerial.print("   Setting Month    ");
  }

  watch.gettime();
  mySerial.print(watch.Hours / 10);
  mySerial.print(watch.Hours % 10);
  mySerial.print(":");
  mySerial.print(watch.minutes / 10);
  mySerial.print(watch.minutes % 10);
  mySerial.print(":");
  mySerial.print(watch.seconds / 10);
  mySerial.print(watch.seconds % 10);
  mySerial.print("  ");
  mySerial.print(watch.gettime("D"));
  mySerial.print(" ");
  mySerial.print(watch.day / 10);
  mySerial.print(watch.day % 10);
  mySerial.print(" ");
  mySerial.print(watch.gettime("M"));
  //  mySerial.print("      ");
  //  mySerial.print(watch.Hours / 10);
  //  mySerial.print(watch.Hours % 10);
  //  mySerial.print(":");
  //  mySerial.print(watch.minutes / 10);
  //  mySerial.print(watch.minutes % 10);
  //  mySerial.print(":");
  //  mySerial.print(watch.seconds / 10);
  //  mySerial.print(watch.seconds % 10);
  //  mySerial.print("      ");
  //__________________________________________Минуты
  if ((min_hour == 1) && butt2.isClick() ) {
    //flag2 = 0;
    int m = (watch.minutes + 1);
    if (m >= 60) m = 0;
    watch.settime(-1, m);
  }
  if ((min_hour == 1) && butt2.isHold() ) {
    int m = (watch.minutes + 1);
    if (m >= 60) m = 0;
    watch.settime(-1, m);
  }
  if ((min_hour == 1) && butt3.isClick()) {
    // flag2 = 0;
    int m = (watch.minutes - 1);
    if (m < 0) m = 59;
    watch.settime(-1, m);
  }
  if ((min_hour == 1) && butt3.isHold()) {
    int m = (watch.minutes - 1);
    if (m < 0) m = 59;
    watch.settime(-1, m);
  }

  //__________________________________________Часы
  if ((min_hour == 0) && butt2.isClick() ) {
    int m = (watch.Hours + 1);
    if (m >= 24) m = 0;
    watch.settime(-1, -1,  m);
  }
  if ((min_hour == 0) && butt2.isHold() ) {
    int m = (watch.Hours + 1);
    if (m >= 24) m = 0;
    watch.settime(-1, -1,  m);
  }
  if ((min_hour == 0) && butt3.isClick() ) {
    int m = (watch.Hours - 1);
    if (m < 0) m = 23;
    watch.settime(-1, -1,  m);
  }
  if ((min_hour == 0) && butt3.isHold() ) {
    int m = (watch.Hours - 1);
    if (m < 0) m = 23;
    watch.settime(-1, -1,  m);
  }
  //__________________________________________Секунды
  if ((min_hour == 2) && butt2.isClick()) {
    watch.settime(0);
  }
  if ((min_hour == 2) && butt3.isClick()) {
    watch.settime(0);
  }
  //__________________________________________День недели
  if ((min_hour == 3) && butt2.isClick()) {
    int m = (watch.weekday + 1);
    if (m > 6) m = 0;
    watch.settime(-1, -1, -1, -1, -1, -1, m);
  }
  if ((min_hour == 3) && butt3.isClick()) {
    int m = (watch.weekday - 1);
    if (m < 0) m = 6;
    watch.settime(-1, -1, -1, -1, -1, -1, m);
  }
  //__________________________________________День месяца
  if ((min_hour == 4) && butt2.isClick()) {
    int m = (watch.day + 1);
    if (m > 31) m = 1;
    watch.settime(-1, -1, -1, m);
  }
  if ((min_hour == 4) && butt3.isClick()) {
    int m = (watch.day - 1);
    if (m < 1) m = 31;
    watch.settime(-1, -1, -1, m);
  }
  //__________________________________________Месяц
  if ((min_hour == 5) && butt2.isClick()) {
    int m = (watch.month + 1);
    if (m > 12) m = 1;
    watch.settime(-1, -1, -1, -1, m);
  }
  if ((min_hour == 5) && butt3.isClick()) {
    int m = (watch.month - 1);
    if (m < 1) m = 12;
    watch.settime(-1, -1, -1, -1, m);
  }

}
//__________________________________________Фильтр значений для датчика света (среднее арифметическое из последних 10 значений)
//
//uint8_t Light(int newVal) { //________________принимает новое значение
//  valArray[idx] = newVal;  //_________________пишем каждый раз в новую ячейку
//  if (++idx >= 10) idx = 0; //________________перезаписывая самое старое значение
//  average = 0;             //_________________обнуляем среднее
//  for (int i = 0; i < 10; i++) {
//    average += valArray[i]; //________________суммируем
//  }
//  average /= 10;            //________________делим
//  return average;           //________________возвращаем
//}
